Index: drivers/char/n_hdlc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/n_hdlc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/n_hdlc.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/n_hdlc.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -9,7 +9,7 @@
  *	Al Longyear <longyear@netcom.com>, Paul Mackerras <Paul.Mackerras@cs.anu.edu.au>
  *
  * Original release 01/11/99
- * $Id: n_hdlc.c,v 1.1 2004/07/22 19:49:51 joff Exp $
+ * $Id: n_hdlc.c,v 1.2 2004/08/04 01:28:44 joff Exp $
  *
  * This code is released under the GNU General Public License (GPL)
  *
@@ -78,7 +78,7 @@
  */
 
 #define HDLC_MAGIC 0x239e
-#define HDLC_VERSION "$Revision: 1.1 $"
+#define HDLC_VERSION "$Revision: 1.2 $"
 
 #include <linux/version.h>
 #include <linux/config.h>
@@ -172,9 +172,9 @@
 /*
  * HDLC buffer list manipulation functions
  */
-void n_hdlc_buf_list_init(N_HDLC_BUF_LIST *list);
-void n_hdlc_buf_put(N_HDLC_BUF_LIST *list,N_HDLC_BUF *buf);
-N_HDLC_BUF* n_hdlc_buf_get(N_HDLC_BUF_LIST *list);
+static void n_hdlc_buf_list_init(N_HDLC_BUF_LIST *list);
+static void n_hdlc_buf_put(N_HDLC_BUF_LIST *list,N_HDLC_BUF *buf);
+static N_HDLC_BUF* n_hdlc_buf_get(N_HDLC_BUF_LIST *list);
 
 /* Local functions */
 
@@ -183,13 +183,16 @@
 MODULE_PARM(debuglevel, "i");
 MODULE_PARM(maxframe, "i");
 
+#ifdef MODULE_LICENSE
+MODULE_LICENSE("GPL");
+#endif
 
 /* debug level can be set by insmod for debugging purposes */
 #define DEBUG_LEVEL_INFO	1
-int debuglevel=0;
+static int debuglevel=0;
 
 /* max frame size for memory allocations */
-ssize_t	maxframe=4096;
+static ssize_t	maxframe=4096;
 
 /* TTY callbacks */
 
@@ -265,7 +268,8 @@
 		} else
 			break;
 	}
-	
+	if (n_hdlc->tbuf)
+		kfree(n_hdlc->tbuf);
 	kfree(n_hdlc);
 	
 }	/* end of n_hdlc_release() */
@@ -905,7 +909,7 @@
  * Arguments:	 	list	pointer to buffer list
  * Return Value:	None	
  */
-void n_hdlc_buf_list_init(N_HDLC_BUF_LIST *list)
+static void n_hdlc_buf_list_init(N_HDLC_BUF_LIST *list)
 {
 	memset(list,0,sizeof(N_HDLC_BUF_LIST));
 	spin_lock_init(&list->spinlock);
@@ -922,7 +926,7 @@
  * 
  * Return Value:	None	
  */
-void n_hdlc_buf_put(N_HDLC_BUF_LIST *list,N_HDLC_BUF *buf)
+static void n_hdlc_buf_put(N_HDLC_BUF_LIST *list,N_HDLC_BUF *buf)
 {
 	unsigned long flags;
 	spin_lock_irqsave(&list->spinlock,flags);
@@ -952,7 +956,7 @@
  * 
  * 	pointer to HDLC buffer if available, otherwise NULL
  */
-N_HDLC_BUF* n_hdlc_buf_get(N_HDLC_BUF_LIST *list)
+static N_HDLC_BUF* n_hdlc_buf_get(N_HDLC_BUF_LIST *list)
 {
 	unsigned long flags;
 	N_HDLC_BUF *buf;
@@ -1025,5 +1029,4 @@
 module_init(n_hdlc_init);
 module_exit(n_hdlc_exit);
 
-MODULE_LICENSE("GPL");
 EXPORT_NO_SYMBOLS;
Index: drivers/char/n_r3964.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/n_r3964.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/n_r3964.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/n_r3964.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -13,8 +13,8 @@
  * L. Haag
  *
  * $Log: n_r3964.c,v $
- * Revision 1.1  2004/07/22 19:49:51  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:28:44  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.8  2000/03/23 14:14:54  dwmw2
  * Fix race in sleeping in r3964_read()
@@ -220,7 +220,7 @@
 {
    int status;
    
-   printk ("r3964: Philips r3964 Driver $Revision: 1.1 $\n");
+   printk ("r3964: Philips r3964 Driver $Revision: 1.2 $\n");
 
    /*
     * Register the tty line discipline
Index: drivers/char/n_tty.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/n_tty.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/char/n_tty.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/n_tty.c	7 Mar 2008 19:32:51 -0000	1.3
@@ -962,7 +962,7 @@
 	ssize_t retval = 0;
 	ssize_t size;
 	long timeout;
-	unsigned long flags;
+	unsigned long flags,flags2;
 
 do_it_again:
 
@@ -1021,6 +1021,7 @@
 	}
 
 	add_wait_queue(&tty->read_wait, &wait);
+	save_flags_cli(flags2);
 	set_bit(TTY_DONT_FLIP, &tty->flags);
 	while (nr) {
 		/* First test for status change. */
@@ -1061,7 +1062,9 @@
 				break;
 			}
 			clear_bit(TTY_DONT_FLIP, &tty->flags);
+			restore_flags(flags2);
 			timeout = schedule_timeout(timeout);
+			save_flags_cli(flags2);
 			set_bit(TTY_DONT_FLIP, &tty->flags);
 			continue;
 		}
@@ -1128,6 +1131,7 @@
 			timeout = time;
 	}
 	clear_bit(TTY_DONT_FLIP, &tty->flags);
+	restore_flags(flags2);
 	up(&tty->atomic_read);
 	remove_wait_queue(&tty->read_wait, &wait);
 
@@ -1238,7 +1242,8 @@
 		else
 			tty->minimum_to_wake = 1;
 	}
-	if (tty->driver.chars_in_buffer(tty) < WAKEUP_CHARS)
+	if (tty->driver.chars_in_buffer(tty) < WAKEUP_CHARS &&
+			tty->driver.write_room(tty) > 0)
 		mask |= POLLOUT | POLLWRNORM;
 	return mask;
 }
Index: drivers/char/pcwd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/pcwd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/pcwd.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/pcwd.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -933,8 +933,7 @@
 
 	release_region (pcwd_info.io_addr, pcwd_info.card_info->io_size);
 
-	if (pcwd_info.flags & PCWD_PCI_REG)
-		pci_unregister_driver (&pcwd_driver);
+	pci_unregister_driver (&pcwd_driver);
 
 	return;
 }
Index: drivers/char/q40_keyb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/q40_keyb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/q40_keyb.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/q40_keyb.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -400,7 +400,7 @@
 #define KBD_NO_DATA	(-1)	/* No data */
 #define KBD_BAD_DATA	(-2)	/* Parity or other error */
 
-static int __init kbd_read_input(void)
+static int __init q40kbd_read_input(void)
 {
 	int retval = KBD_NO_DATA;
 	unsigned char status;
@@ -421,7 +421,7 @@
 	int maxread = 100;	/* Random number */
 
 	do {
-		if (kbd_read_input() == KBD_NO_DATA)
+		if (q40kbd_read_input() == KBD_NO_DATA)
 			break;
 	} while (--maxread);
 }
Index: drivers/char/qtronixmap.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/qtronixmap.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/qtronixmap.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/qtronixmap.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -226,40 +226,40 @@
 };
 
 struct kbdiacr accent_table[MAX_DIACR] = {
-	{'`', 'A', 'À'},	{'`', 'a', 'à'},
-	{'\'', 'A', 'Á'},	{'\'', 'a', 'á'},
-	{'^', 'A', 'Â'},	{'^', 'a', 'â'},
-	{'~', 'A', 'Ã'},	{'~', 'a', 'ã'},
-	{'"', 'A', 'Ä'},	{'"', 'a', 'ä'},
-	{'O', 'A', 'Å'},	{'o', 'a', 'å'},
-	{'0', 'A', 'Å'},	{'0', 'a', 'å'},
-	{'A', 'A', 'Å'},	{'a', 'a', 'å'},
-	{'A', 'E', 'Æ'},	{'a', 'e', 'æ'},
-	{',', 'C', 'Ç'},	{',', 'c', 'ç'},
-	{'`', 'E', 'È'},	{'`', 'e', 'è'},
-	{'\'', 'E', 'É'},	{'\'', 'e', 'é'},
-	{'^', 'E', 'Ê'},	{'^', 'e', 'ê'},
-	{'"', 'E', 'Ë'},	{'"', 'e', 'ë'},
-	{'`', 'I', 'Ì'},	{'`', 'i', 'ì'},
-	{'\'', 'I', 'Í'},	{'\'', 'i', 'í'},
-	{'^', 'I', 'Î'},	{'^', 'i', 'î'},
-	{'"', 'I', 'Ï'},	{'"', 'i', 'ï'},
-	{'-', 'D', 'Ð'},	{'-', 'd', 'ð'},
-	{'~', 'N', 'Ñ'},	{'~', 'n', 'ñ'},
-	{'`', 'O', 'Ò'},	{'`', 'o', 'ò'},
-	{'\'', 'O', 'Ó'},	{'\'', 'o', 'ó'},
-	{'^', 'O', 'Ô'},	{'^', 'o', 'ô'},
-	{'~', 'O', 'Õ'},	{'~', 'o', 'õ'},
-	{'"', 'O', 'Ö'},	{'"', 'o', 'ö'},
-	{'/', 'O', 'Ø'},	{'/', 'o', 'ø'},
-	{'`', 'U', 'Ù'},	{'`', 'u', 'ù'},
-	{'\'', 'U', 'Ú'},	{'\'', 'u', 'ú'},
-	{'^', 'U', 'Û'},	{'^', 'u', 'û'},
-	{'"', 'U', 'Ü'},	{'"', 'u', 'ü'},
-	{'\'', 'Y', 'Ý'},	{'\'', 'y', 'ý'},
-	{'T', 'H', 'Þ'},	{'t', 'h', 'þ'},
-	{'s', 's', 'ß'},	{'"', 'y', 'ÿ'},
-	{'s', 'z', 'ß'},	{'i', 'j', 'ÿ'},
+	{'`', 'A', '\300'},	{'`', 'a', '\340'},
+	{'\'', 'A', '\301'},	{'\'', 'a', '\341'},
+	{'^', 'A', '\302'},	{'^', 'a', '\342'},
+	{'~', 'A', '\303'},	{'~', 'a', '\343'},
+	{'"', 'A', '\304'},	{'"', 'a', '\344'},
+	{'O', 'A', '\305'},	{'o', 'a', '\345'},
+	{'0', 'A', '\305'},	{'0', 'a', '\345'},
+	{'A', 'A', '\305'},	{'a', 'a', '\345'},
+	{'A', 'E', '\306'},	{'a', 'e', '\346'},
+	{',', 'C', '\307'},	{',', 'c', '\347'},
+	{'`', 'E', '\310'},	{'`', 'e', '\350'},
+	{'\'', 'E', '\311'},	{'\'', 'e', '\351'},
+	{'^', 'E', '\312'},	{'^', 'e', '\352'},
+	{'"', 'E', '\313'},	{'"', 'e', '\353'},
+	{'`', 'I', '\314'},	{'`', 'i', '\354'},
+	{'\'', 'I', '\315'},	{'\'', 'i', '\355'},
+	{'^', 'I', '\316'},	{'^', 'i', '\356'},
+	{'"', 'I', '\317'},	{'"', 'i', '\357'},
+	{'-', 'D', '\320'},	{'-', 'd', '\360'},
+	{'~', 'N', '\321'},	{'~', 'n', '\361'},
+	{'`', 'O', '\322'},	{'`', 'o', '\362'},
+	{'\'', 'O', '\323'},	{'\'', 'o', '\363'},
+	{'^', 'O', '\324'},	{'^', 'o', '\364'},
+	{'~', 'O', '\325'},	{'~', 'o', '\365'},
+	{'"', 'O', '\326'},	{'"', 'o', '\366'},
+	{'/', 'O', '\330'},	{'/', 'o', '\370'},
+	{'`', 'U', '\331'},	{'`', 'u', '\371'},
+	{'\'', 'U', '\332'},	{'\'', 'u', '\372'},
+	{'^', 'U', '\333'},	{'^', 'u', '\373'},
+	{'"', 'U', '\334'},	{'"', 'u', '\374'},
+	{'\'', 'Y', '\335'},	{'\'', 'y', '\375'},
+	{'T', 'H', '\336'},	{'t', 'h', '\376'},
+	{'s', 's', '\337'},	{'"', 'y', '\377'},
+	{'s', 'z', '\337'},	{'i', 'j', '\377'},
 };
 
 unsigned int accent_table_size = 68;
Index: drivers/char/random.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/random.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/random.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/random.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -175,7 +175,7 @@
  *	chmod 600 $random_seed
  *	poolfile=/proc/sys/kernel/random/poolsize
  *	[ -r $poolfile ] && bytes=`cat $poolfile` || bytes=512
- *	dd if=/dev/urandom of=$random_seed count=1 bs=bytes
+ *	dd if=/dev/urandom of=$random_seed count=1 bs=$bytes
  *
  * and the following lines in an appropriate script which is run as
  * the system is shutdown:
@@ -188,7 +188,7 @@
  *	chmod 600 $random_seed
  *	poolfile=/proc/sys/kernel/random/poolsize
  *	[ -r $poolfile ] && bytes=`cat $poolfile` || bytes=512
- *	dd if=/dev/urandom of=$random_seed count=1 bs=bytes
+ *	dd if=/dev/urandom of=$random_seed count=1 bs=$bytes
  *
  * For example, on most modern systems using the System V init
  * scripts, such code fragments would be found in
@@ -251,6 +251,8 @@
 #include <linux/random.h>
 #include <linux/poll.h>
 #include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/spinlock.h>
 
 #include <asm/processor.h>
 #include <asm/uaccess.h>
@@ -713,7 +715,9 @@
 static struct timer_rand_state keyboard_timer_state;
 static struct timer_rand_state mouse_timer_state;
 static struct timer_rand_state extract_timer_state;
+#ifndef CONFIG_ARCH_S390
 static struct timer_rand_state *irq_timer_state[NR_IRQS];
+#endif
 static struct timer_rand_state *blkdev_timer_state[MAX_BLKDEV];
 
 /*
@@ -789,6 +793,7 @@
 	batch_entropy_store(num, time, entropy);
 }
 
+#ifndef CONFIG_ARCH_S390
 void add_keyboard_randomness(unsigned char scancode)
 {
 	static unsigned char last_scancode;
@@ -811,6 +816,7 @@
 
 	add_timer_randomness(irq_timer_state[irq], 0x100+irq);
 }
+#endif
 
 void add_blkdev_randomness(int major)
 {
@@ -1443,8 +1449,10 @@
 #ifdef CONFIG_SYSCTL
 	sysctl_init_random(random_state);
 #endif
+#ifndef CONFIG_ARCH_S390
 	for (i = 0; i < NR_IRQS; i++)
 		irq_timer_state[i] = NULL;
+#endif
 	for (i = 0; i < MAX_BLKDEV; i++)
 		blkdev_timer_state[i] = NULL;
 	memset(&keyboard_timer_state, 0, sizeof(struct timer_rand_state));
@@ -1453,6 +1461,7 @@
 	extract_timer_state.dont_count_entropy = 1;
 }
 
+#ifndef CONFIG_ARCH_S390
 void rand_initialize_irq(int irq)
 {
 	struct timer_rand_state *state;
@@ -1470,6 +1479,7 @@
 		irq_timer_state[irq] = state;
 	}
 }
+#endif
 
 void rand_initialize_blkdev(int major, int mode)
 {
@@ -2069,7 +2079,7 @@
 static struct keydata *__check_and_rekey(time_t time)
 {
 	struct keydata *keyptr;
-	spin_lock(&ip_lock);
+	spin_lock_bh(&ip_lock);
 	keyptr = &ip_keydata[ip_cnt&1];
 	if (!keyptr->rekey_time || (time - keyptr->rekey_time) > REKEY_INTERVAL) {
 		keyptr = &ip_keydata[1^(ip_cnt&1)];
@@ -2079,7 +2089,7 @@
 		mb();
 		ip_cnt++;
 	}
-	spin_unlock(&ip_lock);
+	spin_unlock_bh(&ip_lock);
 	return keyptr;
 }
 
@@ -2302,9 +2312,11 @@
 
 
 
+#ifndef CONFIG_ARCH_S390
 EXPORT_SYMBOL(add_keyboard_randomness);
 EXPORT_SYMBOL(add_mouse_randomness);
 EXPORT_SYMBOL(add_interrupt_randomness);
+#endif
 EXPORT_SYMBOL(add_blkdev_randomness);
 EXPORT_SYMBOL(batch_entropy_store);
 EXPORT_SYMBOL(generate_random_uuid);
Index: drivers/char/rocket.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/rocket.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/rocket.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/rocket.c	4 Aug 2004 01:28:44 -0000	1.2
@@ -1944,6 +1944,10 @@
 		str = "8J";
 		max_num_aiops = 1;
 		break;
+	case PCI_DEVICE_ID_RP4J:
+		str = "4J";
+		max_num_aiops = 1;
+		break;
 	case PCI_DEVICE_ID_RP16INTF:
 		str = "16";
 		max_num_aiops = 2;
@@ -2006,6 +2010,10 @@
 			PCI_DEVICE_ID_RP8J, i, &bus, &device_fn)) 
 			if (register_PCI(count+boards_found, bus, device_fn))
 				count++;
+		if (!pcibios_find_device(PCI_VENDOR_ID_RP,
+			PCI_DEVICE_ID_RP4J, i, &bus, &device_fn)) 
+			if (register_PCI(count+boards_found, bus, device_fn))
+				count++;
 		if(!pcibios_find_device(PCI_VENDOR_ID_RP,
 			PCI_DEVICE_ID_RP8OCTA, i, &bus, &device_fn)) 
 			if(register_PCI(count+boards_found, bus, device_fn))
@@ -2031,6 +2039,10 @@
 			if(register_PCI(count+boards_found, bus, device_fn))
 				count++;
 		if(!pcibios_find_device(PCI_VENDOR_ID_RP,
+			PCI_DEVICE_ID_RP4J, i, &bus, &device_fn)) 
+			if(register_PCI(count+boards_found, bus, device_fn))
+				count++;
+		if(!pcibios_find_device(PCI_VENDOR_ID_RP,
 			PCI_DEVICE_ID_RPP4, i, &bus, &device_fn)) 
 			if(register_PCI(count+boards_found, bus, device_fn))
 				count++;
Index: drivers/char/rocket_int.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/rocket_int.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/rocket_int.h	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/rocket_int.h	4 Aug 2004 01:28:44 -0000	1.2
@@ -7,6 +7,8 @@
  * 
  * Copyright 1994 Comtrol Corporation.    All Rights Reserved.
  * 
+ * Erroneously clashing license removed. This file is GPL
+ * (Kurt Robideau, Comtrol Corp, 20030610)
  * This driver is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2, or (at your option)
@@ -16,7 +18,6 @@
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- * 
  */
 
 /*
@@ -1199,6 +1200,9 @@
 #ifndef PCI_DEVICE_ID_RP8J
 #define PCI_DEVICE_ID_RP8J		0x0006
 #endif
+#ifndef PCI_DEVICE_ID_RP4J
+#define PCI_DEVICE_ID_RP4J		0x0007
+#endif
 #ifndef PCI_DEVICE_ID_RPP4
 #define PCI_DEVICE_ID_RPP4		0x000A
 #endif
Index: drivers/char/rtc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/rtc.c,v
retrieving revision 1.1
retrieving revision 1.9
diff -u -r1.1 -r1.9
--- drivers/char/rtc.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/char/rtc.c	16 Jan 2009 19:55:40 -0000	1.9
@@ -35,17 +35,16 @@
  *	1.09a	Pete Zaitcev: Sun SPARC
  *	1.09b	Jeff Garzik: Modularize, init cleanup
  *	1.09c	Jeff Garzik: SMP cleanup
- *	1.10    Paul Barton-Davis: add support for async I/O
+ *	1.10	Paul Barton-Davis: add support for async I/O
  *	1.10a	Andrea Arcangeli: Alpha updates
  *	1.10b	Andrew Morton: SMP lock fix
  *	1.10c	Cesar Barros: SMP locking fixes and cleanup
  *	1.10d	Paul Gortmaker: delete paranoia check in rtc_exit
  *	1.10e	Maciej W. Rozycki: Handle DECstation's year weirdness.
+ *	1.10f	Maciej W. Rozycki: Handle memory-mapped chips properly.
  */
 
-#define RTC_VERSION		"1.10e"
-
-#define RTC_IO_EXTENT	0x10	/* Only really two ports, but...	*/
+#define RTC_VERSION		"1.10f"
 
 /*
  *	Note that *all* calls to CMOS_READ and CMOS_WRITE are done with
@@ -68,6 +67,7 @@
 #include <linux/proc_fs.h>
 #include <linux/spinlock.h>
 #include <linux/sysctl.h>
+#include <linux/delay.h>
 
 #include <asm/io.h>
 #include <asm/uaccess.h>
@@ -80,11 +80,269 @@
 #include <asm/isa.h>
 #endif
 
+
+
 static unsigned long rtc_port;
 static int rtc_irq = PCI_IRQ_NONE;
 #endif
 
+#if RTC_IRQ
 static int rtc_has_irq = 1;
+#endif
+
+int cmos_method_old = 1, cmos_method_boc = 0;
+
+#define TS_MODEL_REG 0x2000000
+#define TS_MODEL_7400 4
+
+//Prosoft RTC support
+volatile static unsigned char *ts7350_rtc = NULL;
+volatile static unsigned short *ts7350_pc104 = NULL;
+
+#define TS7350_RTC_BASE                 0x600ff000
+#define TS7350_RTC_SIZE                 0x00001000
+#define TS7350_RTC_INDEX                0x00000870      //0x600ff870
+#define TS7350_RTC_DATA                 0x00000871      //0x600ff871
+#define TS7350_PC104_BASE               0x600ff000
+#define TS7350_PC104_SIZE               0x00000100
+#define TS7350_PC104_A_LOW              0x0000004c      //0x600ff098
+#define TS7350_PC104_A_UPPER            0x0000004d      //0x600ff09a
+#define TS7350_PC104_B_LOW              0x0000004e      //0x600ff09c
+#define TS7350_PC104_B_UPPER            0x0000004f      //0x600ff09e
+#define TS7350_PC104_ISACONF            0x0000006a      //0x600ff0d4
+
+#define RESTORE_PC104 config_pc104(1)
+#define SETUP_PC104 config_pc104(0)
+
+static inline void config_pc104(int restore)
+{
+        static unsigned short a_lower, a_upper, b_lower, b_upper, isaconf;
+
+        if (restore) {
+
+                //save PC/104 status regs
+                ts7350_pc104[TS7350_PC104_A_LOW] = a_lower;
+                ts7350_pc104[TS7350_PC104_A_UPPER] = a_upper;
+                ts7350_pc104[TS7350_PC104_B_LOW] = b_lower;
+                ts7350_pc104[TS7350_PC104_B_UPPER] = b_upper;
+                ts7350_pc104[TS7350_PC104_B_UPPER] = isaconf;
+
+        } else {
+
+                if (!ts7350_rtc)
+                        ts7350_rtc = (unsigned char *)
+                            __ioremap(TS7350_RTC_BASE, TS7350_RTC_SIZE, 0);
+
+                if (!ts7350_pc104)
+                        ts7350_pc104 = (unsigned short *)
+                            __ioremap(TS7350_PC104_BASE, TS7350_PC104_SIZE, 0);
+
+                //save PC/104 status regs
+                a_lower = ts7350_pc104[TS7350_PC104_A_LOW];
+                a_upper = ts7350_pc104[TS7350_PC104_A_UPPER];
+                b_lower = ts7350_pc104[TS7350_PC104_B_LOW];
+                b_upper = ts7350_pc104[TS7350_PC104_B_UPPER];
+                isaconf = ts7350_pc104[TS7350_PC104_ISACONF];
+
+                //configure PC/104 connector for PC/104 bus
+                //we need to do this to talk to the RTC
+                ts7350_pc104[TS7350_PC104_A_LOW] = 0x5555;
+                ts7350_pc104[TS7350_PC104_A_UPPER] = 0x5555;
+                ts7350_pc104[TS7350_PC104_B_LOW] = 0x5555;
+                ts7350_pc104[TS7350_PC104_B_UPPER] = 0x5555;
+
+                //setup PC/104 setup time and hold time
+                ts7350_pc104[TS7350_PC104_ISACONF] = 0x1ef;
+
+                //ensure RTC battery is enabled
+                ts7350_rtc[TS7350_RTC_INDEX] = 0xa;
+                ts7350_rtc[TS7350_RTC_DATA] = 0x20;
+        }
+}
+
+static unsigned char ts7350_rtc_readbyte(unsigned long addr)
+{
+        unsigned char value;
+
+        SETUP_PC104;
+        ts7350_rtc[TS7350_RTC_INDEX] = addr;
+        value = ts7350_rtc[TS7350_RTC_DATA];
+        RESTORE_PC104;
+
+        return value;
+}
+
+static void ts7350_rtc_writebyte(unsigned char value, unsigned long addr)
+{
+        SETUP_PC104;
+        ts7350_rtc[TS7350_RTC_INDEX] = addr;
+        ts7350_rtc[TS7350_RTC_DATA] = value;
+        RESTORE_PC104;
+}
+
+static inline int get_ts_model(void) {
+  return (inw(TS7XXX_IO16_BASE + TS_MODEL_REG)) & 7;
+}
+
+static inline unsigned char CMOSREAD_OLD(int addr) {
+  return CMOS_READ(addr);
+}
+
+static inline unsigned char CMOSWRITE_OLD(unsigned char byte,int addr) {
+  return CMOS_WRITE(byte,addr);
+}
+
+#undef CMOS_READ
+#undef CMOS_WRITE
+
+
+
+static inline unsigned char CMOSREAD_BOC(int addr) {
+  outb_p((addr), BOC_RTCIDX);
+  return inb_p(BOC_RTCDATA);
+}
+
+static inline unsigned char CMOSWRITE_BOC(unsigned char val,int addr) {
+  outb_p((addr), BOC_RTCIDX);
+  outb_p((val), BOC_RTCDATA);
+}
+
+
+void setRTCdata(unsigned char ch) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840000);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840010);
+
+  *ddr = 0xFF;
+  *dr = ch;
+  //printk("DR wrote %02X, read %02X (DDR=%02X)\n",ch,*dr,*ddr);
+}
+
+unsigned char getRTCdata(void) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840000);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840010);
+
+  *ddr = 0x00;
+  return *dr;
+}
+
+void setRTC_RD(int en) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840040);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840044);
+
+  *ddr = *ddr | 8;
+  *dr = !en ? (*dr | 8) : (*dr & 0xF7);
+}
+
+void setRTC_CS(int en) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840040);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840044);
+
+  *ddr = *ddr | 32;
+  *dr = !en ? (*dr | 32) : (*dr & 0xDF);
+}
+
+void setRTC_ALE(int en) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840040);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840044);
+
+  *ddr = *ddr | 16;
+  *dr = en ? (*dr | 16) : (*dr & 0xEF);
+}
+
+void setRTC_WR(int en) {
+  volatile unsigned char *dr = (void *)IO_ADDRESS(0x80840030);
+  volatile unsigned char *ddr = (void *)IO_ADDRESS(0x80840034);
+
+  *ddr = *ddr | 8;
+  *dr = !en ? (*dr | 8) : (*dr & 0xF7);
+}
+
+static inline unsigned char CMOSREAD_NEW(int addr) {
+  unsigned char ch;
+
+  setRTC_RD(0);
+  udelay(1);
+  setRTC_WR(0);
+  udelay(1);
+  setRTC_ALE(0);
+  udelay(1);
+  setRTC_CS(1);
+  udelay(1);
+  setRTCdata(addr);
+  udelay(1);
+  setRTC_ALE(1);
+  udelay(1);
+  setRTC_ALE(0);
+  udelay(1);
+  getRTCdata(); // turn bus around
+  udelay(1);
+  setRTC_RD(1);
+  udelay(1);
+  ch = getRTCdata();
+  udelay(1);
+  setRTC_RD(0);
+  udelay(1);
+  setRTC_CS(0);
+  //printk("CMOS_READ @%X -> %X\n",addr,ch);
+  return ch;
+}
+
+static inline unsigned char CMOSWRITE_NEW(unsigned char ch,int addr) {
+  //printk("CMOS_WRITE @%X <- %X\n",addr,ch);
+  setRTC_RD(0);
+  udelay(1);
+  setRTC_WR(0);
+  udelay(1);
+  setRTC_ALE(0);
+  udelay(1);
+  setRTC_CS(1);
+  udelay(1);
+  setRTC_ALE(1);
+  udelay(1);
+  setRTCdata(addr);
+  udelay(1);
+  setRTC_ALE(0);
+  udelay(1);
+  setRTC_WR(1);
+  udelay(1);
+  setRTCdata(ch);
+  udelay(1);
+  setRTC_WR(0);
+  udelay(1);
+  setRTC_CS(0);
+  return ch;
+}
+
+static inline unsigned char CMOS_READ(int addr) {
+#ifndef CONFIG_PROSOFT_RTC
+  return (cmos_method_boc) ? CMOSREAD_BOC(addr) :
+    (cmos_method_old) ? CMOSREAD_OLD(addr) : CMOSREAD_NEW(addr);
+#else
+return ts7350_rtc_readbyte((unsigned long) addr);
+#endif
+}
+
+static inline unsigned char CMOS_WRITE(unsigned char byte,int addr) {
+#ifndef CONFIG_PROSOFT_RTC
+  return  (cmos_method_boc) ? CMOSWRITE_BOC(byte,addr) :
+    (cmos_method_old) ? CMOSWRITE_OLD(byte,addr):CMOSWRITE_NEW(byte,addr);
+#else
+	ts7350_rtc_writebyte(byte, (unsigned long) addr);
+#endif
+}
+
+void CMOS_INIT(void) {
+#ifndef CONFIG_PROSOFT_RTC
+
+  volatile unsigned *dr = (void *)IO_ADDRESS(0x809300C0);
+  
+  *dr = 0xAA;
+  dr = (void *)IO_ADDRESS(0x80930080);
+  *dr = 0x08140d00;
+#endif
+
+  CMOS_WRITE(0x20,0xa);
+}
 
 /*
  *	We sponge a minor off of the misc major. No need slurping
@@ -97,7 +355,9 @@
 
 static DECLARE_WAIT_QUEUE_HEAD(rtc_wait);
 
+#if RTC_IRQ
 static struct timer_list rtc_irq_timer;
+#endif
 
 static ssize_t rtc_read(struct file *file, char *buf,
 			size_t count, loff_t *ppos);
@@ -238,14 +498,22 @@
 	if (rtc_has_irq == 0)
 		return -EIO;
 
-	if (count < sizeof(unsigned long))
+	/*
+	 * Historically this function used to assume that sizeof(unsigned long)
+	 * is the same in userspace and kernelspace.  This lead to problems
+	 * for configurations with multiple ABIs such a the MIPS o32 and 64
+	 * ABIs supported on the same kernel.  So now we support read of both
+	 * 4 and 8 bytes and assume that's the sizeof(unsigned long) in the
+	 * userspace ABI.
+	 */
+	if (count != sizeof(unsigned int) && count !=  sizeof(unsigned long))
 		return -EINVAL;
 
 	add_wait_queue(&rtc_wait, &wait);
-
-	current->state = TASK_INTERRUPTIBLE;
 		
 	do {
+		__set_current_state(TASK_INTERRUPTIBLE);
+
 		/* First make it right. Then make it fast. Putting this whole
 		 * block within the parentheses of a while would be too
 		 * confusing. And no, xchg() is not the answer. */
@@ -268,9 +536,12 @@
 		schedule();
 	} while (1);
 
-	retval = put_user(data, (unsigned long *)buf); 
+	if (count == sizeof(unsigned int))
+		retval = put_user(data, (unsigned int *)buf); 
+	else
+		retval = put_user(data, (unsigned long *)buf);
 	if (!retval)
-		retval = sizeof(unsigned long); 
+		retval = count;
  out:
 	current->state = TASK_RUNNING;
 	remove_wait_queue(&rtc_wait, &wait);
@@ -362,7 +633,7 @@
 		 * means "don't care" or "match all". Only the tm_hour,
 		 * tm_min, and tm_sec values are filled in.
 		 */
-
+		memset(&wtime, 0, sizeof(struct rtc_time));
 		get_rtc_alm_time(&wtime);
 		break; 
 	}
@@ -406,6 +677,7 @@
 	}
 	case RTC_RD_TIME:	/* Read the time/date from RTC	*/
 	{
+		memset(&wtime, 0, sizeof(struct rtc_time));
 		get_rtc_time(&wtime);
 		break;
 	}
@@ -706,6 +978,14 @@
 	struct isa_device *isa_dev;
 #endif
 #endif
+#ifndef __sparc__
+	void *r;
+#endif
+
+	if (get_ts_model() == 4) {
+	  printk("Using DIO to access RTC\n");
+	  cmos_method_old = 0;
+	}
 
 #ifdef __sparc__
 	for_each_ebus(ebus) {
@@ -752,18 +1032,56 @@
 	}
 no_irq:
 #else
-	if (!request_region(RTC_PORT(0), RTC_IO_EXTENT, "rtc"))
+
+#ifdef CONFIG_TS_RTC
 	{
-		printk(KERN_ERR "rtc: I/O port %d is not free.\n", RTC_PORT (0));
+		unsigned char i;
+
+		CMOS_INIT();
+		CMOS_WRITE(0xaa, 0x7f);
+		i = CMOS_READ(0x7f) ^ 0xaa;
+		CMOS_WRITE(0x55, 0x7e);
+		i |= CMOS_READ(0x7e) ^ 0x55;
+		if (i != 0) {
+		  if (cmos_method_old) {
+		    cmos_method_boc = 1;
+		    CMOS_INIT(); // try the above again with BOC access method
+		    CMOS_WRITE(0xaa, 0x7f);
+		    i = CMOS_READ(0x7f) ^ 0xaa;
+		    CMOS_WRITE(0x55, 0x7e);
+		    i |= CMOS_READ(0x7e) ^ 0x55;
+		  }
+		  if (i != 0) {
+		    cmos_method_boc = 0;
+		    printk("rtc: no TS-5620 RTC detected.\n");
+		    return -EIO;
+		  }
+		}
+		while((CMOS_READ(0xa) & 0x80) != 0);
+		// BCD mode, 24 hr mode
+		CMOS_WRITE(0x2, 0xb);
+
+	}
+#endif
+
+	if (RTC_IOMAPPED)
+		r = request_region(RTC_PORT(0), RTC_IO_EXTENT, "rtc");
+	else
+		r = request_mem_region(RTC_PORT(0), RTC_IO_EXTENT, "rtc");
+	if (!r) {
+		printk(KERN_ERR "rtc: I/O resource %lx is not free.\n",
+		       (long)(RTC_PORT(0)));
 		return -EIO;
 	}
 
 #if RTC_IRQ
-	if(request_irq(RTC_IRQ, rtc_interrupt, SA_INTERRUPT, "rtc", NULL))
-	{
+	if(request_irq(RTC_IRQ, rtc_interrupt, SA_INTERRUPT, "rtc", NULL)) {
 		/* Yeah right, seeing as irq 8 doesn't even hit the bus. */
 		printk(KERN_ERR "rtc: IRQ %d is not free.\n", RTC_IRQ);
-		release_region(RTC_PORT(0), RTC_IO_EXTENT);
+		if (RTC_IOMAPPED)
+			release_region(RTC_PORT(0), RTC_IO_EXTENT);
+		else
+			release_mem_region(RTC_PORT(0), RTC_IO_EXTENT);
 		return -EIO;
 	}
 #endif
@@ -847,7 +1165,10 @@
 	if (rtc_has_irq)
 		free_irq (rtc_irq, &rtc_port);
 #else
-	release_region (RTC_PORT (0), RTC_IO_EXTENT);
+	if (RTC_IOMAPPED)
+		release_region(RTC_PORT(0), RTC_IO_EXTENT);
+	else
+		release_mem_region(RTC_PORT(0), RTC_IO_EXTENT);
 #if RTC_IRQ
 	if (rtc_has_irq)
 		free_irq (RTC_IRQ, NULL);
